clc
clear 
run online_run

%for i=1:4

nr=1;  % which of 4 profiles to test.. 

%for original iceberg sail plot
inputx=plotsail(1:8,nr);
inputy=plotsail(9:16,nr);
input=[inputx';inputy'];

%for original iceberg keel plot
targetx=testtargetshape(1:8,nr);
targety=testtargetshape(9:16,nr);
output=[targetx';targety'];

%input iceberg sail to network. 
x1= testinputshape(:,nr);
[y1] = myNeuralNetworkBayesianShape(x1);

%preparing estimate keel for plot 
y1x=y1(1:8);
y1y=y1(9:16);
outputs=[y1x';y1y'];

%%%%%%%%%%%%%%%%%
%%%%Plots%%%%%%%%

%plotting iceberg sail 
poly_draw = [input input(:,1)];
 plot(poly_draw(1,:), poly_draw(2,:),'r')
 hold on

 
poly_draw = [outputs outputs(:,1)];
plot(poly_draw(1,:), poly_draw(2,:),'b --')




title('Estimated iceberg keel geometry from keel shape factors ');
poly_draw = [output output(:,1)];
plot(poly_draw(1,:), poly_draw(2,:),'g')
xlabel({'Widht','[-]'})
ylabel({'Height','[-]'})
legend('Iceberg sail ','Estimated iceberg keel ','Real iceberg keel')
axis( [ -1 1  -1  1 ] )
xlabel({'Width','[-]'})
ylabel({'Height','[-]'})


%end