%Script creates GZ curves. 


clc
clear all

Run_create_shape % Creates the shape estimates 

int=10; %degree interval to calculate the GZ curve
d2r= pi/180;
for P=1:3 %loop for calculating the different geometries
  
    nx=totx(P,:);
    ny=toty(P,:);
     
vinkel = -int:1:int;
for i=1:length(vinkel)

[x,y]=roter(nx,ny,vinkel(i)); %rotates the iceberg to calculate GZ at every angle. 
 plotter(x,y);
 hold on
 %theta(vinkel)=vinkel*pi / 180;
 
% Uses Matlab code from H.J. Sommer III, see readme for citation. 
[ geom, iner, cpmo ] = polygeom( x, y );

% show results
area = geom(1);%calculates area of iceberg
x_cen = geom(2);%find x value for area center
y_cen = geom(3);%find y valyue for area center 
perimeter = geom(4); %calculates iceberg perimeter 
disp( [ ' ' ] )
disp( [ '3x5 test rectangle with long axis at 30 degrees' ] )
disp( [ ' ' ] )
disp( [ '      area     x_cen     y_cen     perim' ] )
disp( [ area  x_cen  y_cen  perimeter ] )

I1 = cpmo(1); %calculates first moment of inertia
angle1 = cpmo(2); 
I2 = cpmo(3); % calculates second moment of inertia 
angle2 = cpmo(4);
disp( [ ' ' ] )
disp( [ '        I1        I2' ] )
disp( [ I1 I2 ] )
disp( [ '    angle1    angle2' ] )
disp( [ angle1/d2r angle2/d2r ] )

% plot outline
xplot = [ x ; x(1) ];
yplot = [ y ; y(1) ];
rad = 10;
x1 = [ x_cen-rad*cos(angle1)  x_cen+rad*cos(angle1) ];
y1 = [ y_cen-rad*sin(angle1)  y_cen+rad*sin(angle1) ];
x2 = [ x_cen-rad*cos(angle2)  x_cen+rad*cos(angle2) ];
y2 = [ y_cen-rad*sin(angle2)  y_cen+rad*sin(angle2) ];
plot( xplot,yplot,'b', x_cen,y_cen,'ro', ...
      x1,y1,'g:', x2,y2,'g:'  )
axis( [ -150 350  0  300 ] )
axis square



%calculates the center of buoyancy 

[barea,sarea,nymax,gymax,nxmax,gxmax,x_b,y_b]=buoyancy(x,y);

%Saves the different BG_x values.
BG(P,i)=x_cen-x_b;

end

%BG(i)=x_b-x_cen;
end
figure
plot(-int:int,BG(1,1:length(vinkel)),'black');% ekte
grid on
hold on 
plot(-int:int,BG(2,1:length(vinkel)),'red'); % maksimum
plot(-int:int,BG(3,1:length(vinkel)),'green');% minimum
title('GZ curves for the estimated iceberg shapes')
xlabel('Roll angle [degree]') % x-axis label
ylabel('Righting arm (GZ) [m]') % y-axis label
legend('GZ curve for real draft','GZ curve for estimated max draft','GZ curve for estimated min draft','Location','northeast')
